<?php
/**
 * RecommendationRequestDataQuery
 *
 * PHP version 5
 *
 * @category Class
 * @package  Boxx\Loki
 * @author   Swaagger Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */

/**
 * Recommendation API 2
 *
 * No description provided (generated by Boxx Codegen https://github.com/Boxx-api/Boxx-codegen)
 *
 * OpenAPI spec version: 1.5.0
 * 
 * Generated by: https://github.com/Boxx-api/Boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the Boxx code generator program.
 * https://github.com/Boxx-api/Boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxx\Ai\Recco\Model;

use \ArrayAccess;

/**
 * RecommendationRequestDataQuery Class Doc Comment
 *
 * @category    Class
 * @package     Boxx\Loki
 * @author      Boxx Codegen team
 * @link        https://github.com/Boxx-api/Boxx-codegen
 */
class RecommendationRequestDataQuery implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $BoxxModelName = 'recommendation_request_data_query';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $BoxxTypes = [
        'userid' => 'string',
        'boxx_token_id' => 'string',
        'get_product_properties' => 'bool',
        'num' => 'int',
        'user_attribute_weight' => 'float',
        'transaction_weight' => 'float',
        'group_by_attribute' => 'bool',
        'location' => 'double[]',
        'radius' => 'int',
        'item_filters' => 'array',
        'recent_actions' => 'object',
        'repeat' => 'bool',
        'exclude' => 'string[]',
        'num_out_of' => 'float',
        'offset' => 'float',
        'random' => 'double',
        'related_products' => 'string[]',
        'related_action_type' => 'string',
        'dont_repeat_transaction_types' => 'string[]',
        'product_ids' => 'string[]',
        'page_num' => 'float',
        'maximize' => 'string',
        'latest_transactions' => 'bool',
        'ignore_filters' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $BoxxFormats = [
        'userid' => null,
        'boxx_token_id' => null,
        'get_product_properties' => null,
        'num' => null,
        'user_attribute_weight' => 'integer',
        'transaction_weight' => 'integer',
        'group_by_attribute' => null,
        'location' => 'double',
        'radius' => null,
        'item_filters' => null,
        'recent_actions' => null,
        'repeat' => null,
        'exclude' => null,
        'num_out_of' => 'integer',
        'offset' => 'integer',
        'random' => 'double',
        'related_products' => null,
        'related_action_type' => null,
        'dont_repeat_transaction_types' => null,
        'product_ids' => null,
        'page_num' => 'integer',
        'maximize' => null,
        'latest_transactions' => null,
        'ignore_filters' => null
    ];

    public static function BoxxTypes()
    {
        return self::$BoxxTypes;
    }

    public static function BoxxFormats()
    {
        return self::$BoxxFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'userid' => 'userid',
        'boxx_token_id' => 'boxx_token_id',
        'get_product_properties' => 'get_product_properties',
        'num' => 'num',
        'user_attribute_weight' => 'user_attribute_weight',
        'transaction_weight' => 'transaction_weight',
        'group_by_attribute' => 'group_by_attribute',
        'location' => 'location',
        'radius' => 'radius',
        'item_filters' => 'item_filters',
        'recent_actions' => 'recent_actions',
        'repeat' => 'repeat',
        'exclude' => 'exclude',
        'num_out_of' => 'num_out_of',
        'offset' => 'offset',
        'random' => 'random',
        'related_products' => 'related_products',
        'related_action_type' => 'related_action_type',
        'dont_repeat_transaction_types' => 'dont_repeat_transaction_types',
        'product_ids' => 'product_ids',
        'page_num' => 'page_num',
        'maximize' => 'maximize',
        'latest_transactions' => 'latest_transactions',
        'ignore_filters' => 'ignore_filters'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'userid' => 'setUserid',
        'boxx_token_id' => 'setBoxxTokenId',
        'get_product_properties' => 'setGetProductProperties',
        'num' => 'setNum',
        'user_attribute_weight' => 'setUserAttributeWeight',
        'transaction_weight' => 'setTransactionWeight',
        'group_by_attribute' => 'setGroupByAttribute',
        'location' => 'setLocation',
        'radius' => 'setRadius',
        'item_filters' => 'setItemFilters',
        'recent_actions' => 'setRecentActions',
        'repeat' => 'setRepeat',
        'exclude' => 'setExclude',
        'num_out_of' => 'setNumOutOf',
        'offset' => 'setOffset',
        'random' => 'setRandom',
        'related_products' => 'setRelatedProducts',
        'related_action_type' => 'setRelatedActionType',
        'dont_repeat_transaction_types' => 'setDontRepeatTransactionTypes',
        'product_ids' => 'setProductIds',
        'page_num' => 'setPageNum',
        'maximize' => 'setMaximize',
        'latest_transactions' => 'setLatestTransactions',
        'ignore_filters' => 'setIgnoreFilters'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'userid' => 'getUserid',
        'boxx_token_id' => 'getBoxxTokenId',
        'get_product_properties' => 'getGetProductProperties',
        'num' => 'getNum',
        'user_attribute_weight' => 'getUserAttributeWeight',
        'transaction_weight' => 'getTransactionWeight',
        'group_by_attribute' => 'getGroupByAttribute',
        'location' => 'getLocation',
        'radius' => 'getRadius',
        'item_filters' => 'getItemFilters',
        'recent_actions' => 'getRecentActions',
        'repeat' => 'getRepeat',
        'exclude' => 'getExclude',
        'num_out_of' => 'getNumOutOf',
        'offset' => 'getOffset',
        'random' => 'getRandom',
        'related_products' => 'getRelatedProducts',
        'related_action_type' => 'getRelatedActionType',
        'dont_repeat_transaction_types' => 'getDontRepeatTransactionTypes',
        'product_ids' => 'getProductIds',
        'page_num' => 'getPageNum',
        'maximize' => 'getMaximize',
        'latest_transactions' => 'getLatestTransactions',
        'ignore_filters' => 'getIgnoreFilters'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['userid'] = isset($data['userid']) ? $data['userid'] : null;
        $this->container['boxx_token_id'] = isset($data['boxx_token_id']) ? $data['boxx_token_id'] : null;
        $this->container['get_product_properties'] = isset($data['get_product_properties']) ? $data['get_product_properties'] : false;
        $this->container['num'] = isset($data['num']) ? $data['num'] : null;
        $this->container['user_attribute_weight'] = isset($data['user_attribute_weight']) ? $data['user_attribute_weight'] : null;
        $this->container['transaction_weight'] = isset($data['transaction_weight']) ? $data['transaction_weight'] : null;
        $this->container['group_by_attribute'] = isset($data['group_by_attribute']) ? $data['group_by_attribute'] : null;
        $this->container['location'] = isset($data['location']) ? $data['location'] : null;
        $this->container['radius'] = isset($data['radius']) ? $data['radius'] : null;
        $this->container['item_filters'] = isset($data['item_filters']) ? $data['item_filters'] : null;
        $this->container['recent_actions'] = isset($data['recent_actions']) ? $data['recent_actions'] : null;
        $this->container['repeat'] = isset($data['repeat']) ? $data['repeat'] : true;
        $this->container['exclude'] = isset($data['exclude']) ? $data['exclude'] : null;
        $this->container['num_out_of'] = isset($data['num_out_of']) ? $data['num_out_of'] : null;
        $this->container['offset'] = isset($data['offset']) ? $data['offset'] : null;
        $this->container['random'] = isset($data['random']) ? $data['random'] : null;
        $this->container['related_products'] = isset($data['related_products']) ? $data['related_products'] : null;
        $this->container['related_action_type'] = isset($data['related_action_type']) ? $data['related_action_type'] : null;
        $this->container['dont_repeat_transaction_types'] = isset($data['dont_repeat_transaction_types']) ? $data['dont_repeat_transaction_types'] : null;
        $this->container['product_ids'] = isset($data['product_ids']) ? $data['product_ids'] : null;
        $this->container['page_num'] = isset($data['page_num']) ? $data['page_num'] : null;
        $this->container['maximize'] = isset($data['maximize']) ? $data['maximize'] : null;
        $this->container['latest_transactions'] = isset($data['latest_transactions']) ? $data['latest_transactions'] : false;
        $this->container['ignore_filters'] = isset($data['ignore_filters']) ? $data['ignore_filters'] : false;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if (!is_null($this->container['num']) && ($this->container['num'] < 0)) {
            $invalid_properties[] = "invalid value for 'num', must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['user_attribute_weight']) && ($this->container['user_attribute_weight'] > 1)) {
            $invalid_properties[] = "invalid value for 'user_attribute_weight', must be smaller than or equal to 1.";
        }

        if (!is_null($this->container['user_attribute_weight']) && ($this->container['user_attribute_weight'] < 0)) {
            $invalid_properties[] = "invalid value for 'user_attribute_weight', must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['transaction_weight']) && ($this->container['transaction_weight'] > 1)) {
            $invalid_properties[] = "invalid value for 'transaction_weight', must be smaller than or equal to 1.";
        }

        if (!is_null($this->container['transaction_weight']) && ($this->container['transaction_weight'] < 0)) {
            $invalid_properties[] = "invalid value for 'transaction_weight', must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['random']) && ($this->container['random'] > 1)) {
            $invalid_properties[] = "invalid value for 'random', must be smaller than or equal to 1.";
        }

        if (!is_null($this->container['random']) && ($this->container['random'] < 0)) {
            $invalid_properties[] = "invalid value for 'random', must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['page_num']) && ($this->container['page_num'] < 1)) {
            $invalid_properties[] = "invalid value for 'page_num', must be bigger than or equal to 1.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['num'] < 0) {
            return false;
        }
        if ($this->container['user_attribute_weight'] > 1) {
            return false;
        }
        if ($this->container['user_attribute_weight'] < 0) {
            return false;
        }
        if ($this->container['transaction_weight'] > 1) {
            return false;
        }
        if ($this->container['transaction_weight'] < 0) {
            return false;
        }
        if ($this->container['random'] > 1) {
            return false;
        }
        if ($this->container['random'] < 0) {
            return false;
        }
        if ($this->container['page_num'] < 1) {
            return false;
        }
        return true;
    }


    /**
     * Gets userid
     * @return string
     */
    public function getUserid()
    {
        return $this->container['userid'];
    }

    /**
     * Sets userid
     * @param string $userid
     * @return $this
     */
    public function setUserid($userid)
    {
        $this->container['userid'] = $userid;

        return $this;
    }

    /**
     * Gets boxx_token_id
     * @return string
     */
    public function getBoxxTokenId()
    {
        return $this->container['boxx_token_id'];
    }

    /**
     * Sets boxx_token_id
     * @param string $boxx_token_id
     * @return $this
     */
    public function setBoxxTokenId($boxx_token_id)
    {
        $this->container['boxx_token_id'] = $boxx_token_id;

        return $this;
    }

    /**
     * Gets get_product_properties
     * @return bool
     */
    public function getGetProductProperties()
    {
        return $this->container['get_product_properties'];
    }

    /**
     * Sets get_product_properties
     * @param bool $get_product_properties
     * @return $this
     */
    public function setGetProductProperties($get_product_properties)
    {
        $this->container['get_product_properties'] = $get_product_properties;

        return $this;
    }

    /**
     * Gets num
     * @return int
     */
    public function getNum()
    {
        return $this->container['num'];
    }

    /**
     * Sets num
     * @param int $num
     * @return $this
     */
    public function setNum($num)
    {

        if (!is_null($num) && ($num < 0)) {
            throw new \InvalidArgumentException('invalid value for $num when calling RecommendationRequestDataQuery., must be bigger than or equal to 0.');
        }

        $this->container['num'] = $num;

        return $this;
    }

    /**
     * Gets user_attribute_weight
     * @return float
     */
    public function getUserAttributeWeight()
    {
        return $this->container['user_attribute_weight'];
    }

    /**
     * Sets user_attribute_weight
     * @param float $user_attribute_weight
     * @return $this
     */
    public function setUserAttributeWeight($user_attribute_weight)
    {

        if (!is_null($user_attribute_weight) && ($user_attribute_weight > 1)) {
            throw new \InvalidArgumentException('invalid value for $user_attribute_weight when calling RecommendationRequestDataQuery., must be smaller than or equal to 1.');
        }
        if (!is_null($user_attribute_weight) && ($user_attribute_weight < 0)) {
            throw new \InvalidArgumentException('invalid value for $user_attribute_weight when calling RecommendationRequestDataQuery., must be bigger than or equal to 0.');
        }

        $this->container['user_attribute_weight'] = $user_attribute_weight;

        return $this;
    }

    /**
     * Gets transaction_weight
     * @return float
     */
    public function getTransactionWeight()
    {
        return $this->container['transaction_weight'];
    }

    /**
     * Sets transaction_weight
     * @param float $transaction_weight
     * @return $this
     */
    public function setTransactionWeight($transaction_weight)
    {

        if (!is_null($transaction_weight) && ($transaction_weight > 1)) {
            throw new \InvalidArgumentException('invalid value for $transaction_weight when calling RecommendationRequestDataQuery., must be smaller than or equal to 1.');
        }
        if (!is_null($transaction_weight) && ($transaction_weight < 0)) {
            throw new \InvalidArgumentException('invalid value for $transaction_weight when calling RecommendationRequestDataQuery., must be bigger than or equal to 0.');
        }

        $this->container['transaction_weight'] = $transaction_weight;

        return $this;
    }

    /**
     * Gets group_by_attribute
     * @return bool
     */
    public function getGroupByAttribute()
    {
        return $this->container['group_by_attribute'];
    }

    /**
     * Sets group_by_attribute
     * @param bool $group_by_attribute
     * @return $this
     */
    public function setGroupByAttribute($group_by_attribute)
    {
        $this->container['group_by_attribute'] = $group_by_attribute;

        return $this;
    }

    /**
     * Gets location
     * @return double[]
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     * @param double[] $location
     * @return $this
     */
    public function setLocation($location)
    {
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets radius
     * @return int
     */
    public function getRadius()
    {
        return $this->container['radius'];
    }

    /**
     * Sets radius
     * @param int $radius
     * @return $this
     */
    public function setRadius($radius)
    {
        $this->container['radius'] = $radius;

        return $this;
    }

    /**
     * Gets item_filters
     * @return object
     */
    public function getItemFilters()
    {
        return $this->container['item_filters'];
    }

    /**
     * Sets item_filters
     * @param object $item_filters
     * @return $this
     */
    public function setItemFilters($item_filters)
    {
        $this->container['item_filters'] = $item_filters;

        return $this;
    }

    /**
     * Gets recent_actions
     * @return object
     */
    public function getRecentActions()
    {
        return $this->container['recent_actions'];
    }

    /**
     * Sets recent_actions
     * @param object $recent_actions
     * @return $this
     */
    public function setRecentActions($recent_actions)
    {
        $this->container['recent_actions'] = $recent_actions;

        return $this;
    }

    /**
     * Gets repeat
     * @return bool
     */
    public function getRepeat()
    {
        return $this->container['repeat'];
    }

    /**
     * Sets repeat
     * @param bool $repeat
     * @return $this
     */
    public function setRepeat($repeat)
    {
        $this->container['repeat'] = $repeat;

        return $this;
    }

    /**
     * Gets exclude
     * @return string[]
     */
    public function getExclude()
    {
        return $this->container['exclude'];
    }

    /**
     * Sets exclude
     * @param string[] $exclude
     * @return $this
     */
    public function setExclude($exclude)
    {
        $this->container['exclude'] = $exclude;

        return $this;
    }

    /**
     * Gets num_out_of
     * @return float
     */
    public function getNumOutOf()
    {
        return $this->container['num_out_of'];
    }

    /**
     * Sets num_out_of
     * @param float $num_out_of
     * @return $this
     */
    public function setNumOutOf($num_out_of)
    {
        $this->container['num_out_of'] = $num_out_of;

        return $this;
    }

    /**
     * Gets offset
     * @return float
     */
    public function getOffset()
    {
        return $this->container['offset'];
    }

    /**
     * Sets offset
     * @param float $offset
     * @return $this
     */
    public function setOffset($offset)
    {
        $this->container['offset'] = $offset;

        return $this;
    }

    /**
     * Gets random
     * @return double
     */
    public function getRandom()
    {
        return $this->container['random'];
    }

    /**
     * Sets random
     * @param double $random
     * @return $this
     */
    public function setRandom($random)
    {

        if (!is_null($random) && ($random > 1)) {
            throw new \InvalidArgumentException('invalid value for $random when calling RecommendationRequestDataQuery., must be smaller than or equal to 1.');
        }
        if (!is_null($random) && ($random < 0)) {
            throw new \InvalidArgumentException('invalid value for $random when calling RecommendationRequestDataQuery., must be bigger than or equal to 0.');
        }

        $this->container['random'] = $random;

        return $this;
    }

    /**
     * Gets related_products
     * @return string[]
     */
    public function getRelatedProducts()
    {
        return $this->container['related_products'];
    }

    /**
     * Sets related_products
     * @param string[] $related_products
     * @return $this
     */
    public function setRelatedProducts($related_products)
    {
        $this->container['related_products'] = $related_products;

        return $this;
    }

    /**
     * Gets related_action_type
     * @return string
     */
    public function getRelatedActionType()
    {
        return $this->container['related_action_type'];
    }

    /**
     * Sets related_action_type
     * @param string $related_action_type
     * @return $this
     */
    public function setRelatedActionType($related_action_type)
    {
        $this->container['related_action_type'] = $related_action_type;

        return $this;
    }

    /**
     * Gets dont_repeat_transaction_types
     * @return string[]
     */
    public function getDontRepeatTransactionTypes()
    {
        return $this->container['dont_repeat_transaction_types'];
    }

    /**
     * Sets dont_repeat_transaction_types
     * @param string[] $dont_repeat_transaction_types
     * @return $this
     */
    public function setDontRepeatTransactionTypes($dont_repeat_transaction_types)
    {
        $this->container['dont_repeat_transaction_types'] = $dont_repeat_transaction_types;

        return $this;
    }

    /**
     * Gets product_ids
     * @return string[]
     */
    public function getProductIds()
    {
        return $this->container['product_ids'];
    }

    /**
     * Sets product_ids
     * @param string[] $product_ids
     * @return $this
     */
    public function setProductIds($product_ids)
    {
        $this->container['product_ids'] = $product_ids;

        return $this;
    }

    /**
     * Gets page_num
     * @return float
     */
    public function getPageNum()
    {
        return $this->container['page_num'];
    }

    /**
     * Sets page_num
     * @param float $page_num
     * @return $this
     */
    public function setPageNum($page_num)
    {

        if (!is_null($page_num) && ($page_num < 1)) {
            throw new \InvalidArgumentException('invalid value for $page_num when calling RecommendationRequestDataQuery., must be bigger than or equal to 1.');
        }

        $this->container['page_num'] = $page_num;

        return $this;
    }

    /**
     * Gets maximize
     * @return string
     */
    public function getMaximize()
    {
        return $this->container['maximize'];
    }

    /**
     * Sets maximize
     * @param string $maximize
     * @return $this
     */
    public function setMaximize($maximize)
    {
        $this->container['maximize'] = $maximize;

        return $this;
    }

    /**
     * Gets latest_transactions
     * @return bool
     */
    public function getLatestTransactions()
    {
        return $this->container['latest_transactions'];
    }

    /**
     * Sets latest_transactions
     * @param bool $latest_transactions
     * @return $this
     */
    public function setLatestTransactions($latest_transactions)
    {
        $this->container['latest_transactions'] = $latest_transactions;

        return $this;
    }

    /**
     * Gets ignore_filters
     * @return bool
     */
    public function getIgnoreFilters()
    {
        return $this->container['ignore_filters'];
    }

    /**
     * Sets ignore_filters
     * @param bool $ignore_filters
     * @return $this
     */
    public function setIgnoreFilters($ignore_filters)
    {
        $this->container['ignore_filters'] = $ignore_filters;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Boxx\Ai\Recco\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Boxx\Ai\Recco\ObjectSerializer::sanitizeForSerialization($this));
    }
}


